from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import RegularNGon2
from rocolib.api.composables.graph.Face import Rectangle

class Tire(FoldedComponent):
    def define(self):
        self.addParameter("n", 6, valueType="int")
        self.addParameter("radius", 25, paramType="length")
        self.addParameter("twidth", 50, paramType="length")
        self.addParameter("slength", 25, paramType="length")
        #calculation for slength: float(2 * r * np.cos(np.deg2rad(60)))
        #Slength is the side of the rectangle that will attach to the edge of the nonagon

        self.addFaceInterface("face0", "f0")

        #Hardcoded 9 edge interfaces
        for i in range(6):
            try:
                self.setEdgeInterface("e%d" % i, "e%d" % i, "radius")
            except KeyError:
                self.addEdgeInterface("e%d" % i, "e%d" % i, "radius")

    def assemble(self):
        n = self.getParameter("n")
        r = self.getParameter("radius")
        tw = self.getParameter("twidth")
        sl = self.getParameter("slength")

        hexagon = RegularNGon2("", n, r)

        support = []
        for i in range(2):
            support.append(Rectangle("r%d" %i, tw, sl))

        fromEdge = None
        self.attachEdge(fromEdge, support[0], "e2", prefix="r0")
        self.attachEdge(fromEdge, support[1], "e2", prefix="r1")
        self.attachEdge("r0.e1", hexagon, "e0", prefix="hex")
        self.mergeEdge("r1.e1", "hex.e2")

if __name__ == "__main__":
    Tire.test()
